#ifndef _MAILUTIL_H
#define _MAILUTIL_H

#include <stdio.h>

/* Header types */
#define	NOHEADER 	-1
#define APPROVED	0
#define	FROM		1
#define	TO		2
#define	DATE		3
#define	MSGID		4
#define	SUBJECT		5
#define	RECEIVED	6
#define	SENDER		7
#define	REPLYTO		8
#define STATUS		9
#define BBSTYPE		10
#define XFORWARD	11
#define CC		12
#define RRECEIPT	13
#define APPARTO		14
#define ERRORSTO	15
#define ORGANIZATION    16
#define NEWSGROUPS  17
#define PATH        18
#define XBBSHOLD    19
#define UNKNOWN     20

#define IDXTOLEN 13
#define IDXFROMLEN 8
#define IDXSUBLEN 36
#define IDXDATELEN 6

/* Mail index file structure - WG7J */
struct mailindex {
    long msgid;                 /* Internal message number */
    char type;                  /* Message type */
    char status;                /* Message status */
    long size;                  /* Size of message */
    char to[IDXTOLEN+1];        /* To: field */
    char from[IDXFROMLEN+1];    /* From: field */
    char subject[IDXSUBLEN+1];  /* Subject: field */
    char date[IDXDATELEN+1];    /* Date: field */
};

#ifdef MSDOS
#define IDXLINESIZE 84
#else
#define IDXLINESIZE 83
#endif

extern char *Hdrs[];
extern char shortversion[];
extern char *Mbfwdinfo;

int recvmail __ARGS((int s, char *buf, unsigned len, FILE *fp, int trace));
int copymail __ARGS((char *filename,char *buf,
                    unsigned len, FILE *fp, int trace));

int mlock __ARGS((char *dir,char *id));
int rmlock __ARGS((char *dir,char *id));
char *getname __ARGS((char *cp));
char *getaddress __ARGS((char *string,int cont));
int htype __ARGS((char *s));
char *rewrite_address __ARGS((char *addr));

void default_index __ARGS((char *name, struct mailindex *ind));
void set_index __ARGS((char *buf,struct mailindex *index));
void write_index __ARGS((char *name, struct mailindex *ind));
void delete_index __ARGS((char *filename));

#endif  /* _MAILUTIL_H */
